defmodule KatzenplanWeb.KatzenplanLive do
  use Phoenix.LiveView
  import Phoenix.Component

  alias Phoenix.PubSub

  def mount(_params, _session, socket) do
    if connected?(socket) do
      PubSub.subscribe(Katzenplan.PubSub, "katzenplan")
    end

    tage = Katzenplan.Plan.Tag.alle()
    socket =
      socket
      |> assign(:tage, tage)

    {:ok, socket}
  end

  def handle_info({:verantwortlicher_eingetragen, neuer_tag}, socket) do
    socket = update(socket, :tage, fn tage -> Enum.map(tage, fn tag -> aktualisiere_tag(tag, neuer_tag) end) end)
    {:noreply, socket}
  end

  def handle_event("verantwortlicher_eingetragen", params, socket) do
    {:ok, neuer_tag} = Katzenplan.Plan.Tag.aktualisiere(params)
    PubSub.broadcast(Katzenplan.PubSub, "katzenplan", {:verantwortlicher_eingetragen, neuer_tag})
    {:noreply, socket}
  end

  defp aktualisiere_tag(tag, neuer_tag) do
    if tag.id == neuer_tag.id do
      neuer_tag
    else
      tag
    end
  end
end

